<?php

/**
 * $JA#COPYRIGHT$
 */
defined('_JEXEC') or die;

class K2FilterHelper {
	
	function getFilterItems($catid) {

		$lang = JFactory::getLanguage();
		$languages = JLanguageHelper::getLanguages();
		$filterItems = array();
		foreach ($languages AS $lang) {
			$filterItems[str_replace('-', '_', strtolower($lang->lang_code))] = $this->getItemList($catid, $lang);
		}

		return $filterItems;
	}

	function getItemList($catid, $lang) {
		$categories = $this->_fetchElement($catid, '', array());
		$catids = array();
		$catids[] = $catid;
		foreach ($categories AS $cat) {
			$catids[] = $cat->id;
		}
		$db = JFactory::getDBO();
		$nullDate = $db->getNullDate();
		$jnow = JFactory::getDate();
		$now = $jnow->toSql();

		$sql = 'SELECT * FROM #__k2_items i 
		LEFT JOIN #__k2_rating r ON (i.id = r.itemID)
		WHERE i.catid IN (' . implode(',', $catids) . ') AND i.language IN ("*", "' . $lang->lang_code . '")
    	AND i.published = 1
    	AND ( i.publish_up = '.$db->Quote($nullDate).' OR i.publish_up <= '.$db->Quote($now).' )
    	AND ( i.publish_down = '.$db->Quote($nullDate).' OR i.publish_down >= '.$db->Quote($now).' )
		GROUP BY i.id order by i.id desc';
		$db->setQuery($sql);
		$items = $db->loadObjectList();
		$itemList = new stdCLass();

		$sql = 'SELECT * FROM #__k2_extra_fields';
		$db->setQuery($sql);
		$exf = $db->loadObjectList();

		$sql = 'SELECT * FROM #__k2_categories WHERE id IN (' . implode(',', $catids) . ')';
		$db->setQuery($sql);
		$categories = $db->loadObjectList();

		foreach ($items as $id) {
			$property = 'item_' . $id->id;
			$item = $this->getItem($id, $lang, $exf, $categories);
			if (!empty($item))
				$itemList->{ $property } = $item;
			else
				continue;
		}

		return $itemList;
	}

	function getItem($baseItem, $lang, $exf, $categories) {
		$item = new stdClass();
		$item->id = $baseItem->id;
		$item->name = $baseItem->title;
		$item->published = $baseItem->published;
		$item->publish_up = strtotime($baseItem->publish_up);
		$item->publish_down = strtotime($baseItem->publish_down);
		if (!empty($baseItem->rating_sum) && !empty($baseItem->rating_count))
			$item->rating = ($baseItem->rating_sum / $baseItem->rating_count);
		else
			$item->rating = 0;
		$item->width_rating = $item->rating * 20;

		$item->created_date = strtotime($baseItem->created_date);
		$item->modified_date = strtotime($baseItem->modified);

		$item->url = $this->getUrl($baseItem);
		if (JFile::exists('../media/k2/items/cache/' . md5("Image" . $baseItem->id) . '_L.jpg'))
			$item->thumbnail = 'media/k2/items/cache/' . md5("Image" . $baseItem->id) . '_L.jpg';
		$extrafield = json_decode($baseItem->extra_fields);
		$item->attr = array();
		foreach ($extrafield AS $ex) {
			foreach ($exf AS $ef) {
				if ($ex->id == $ef->id) {
					if ($ef->type == 'multipleSelect' || $ef->type == 'radio' || $ef->type == 'select') {
						$item->attr['ct' . $ef->id]['value'] = array();
						$item->attr['ct' . $ef->id]['frontend_value'] = array();
						$realval = json_decode($ef->value);
						$evalue = is_array($ex->value) ? $ex->value : array($ex->value);
						foreach ($realval AS $r) {
							if (in_array($r->value, $evalue)) {
								$item->attr['ct' . $ef->id]['value'][] = (string) $r->value;
								$item->attr['ct' . $ef->id]['frontend_value'][] = $r->name;
							}
						}
					} else if ($ef->type == 'date') {
						$item->attr['ct' . $ef->id]['value'][] = (string) strtotime($ex->value);
						$item->attr['ct' . $ef->id]['frontend_value'][] = (string) strtotime($ex->value);
					} else {
						$item->attr['ct' . $ef->id]['value'] = $ex->value;
						$item->attr['ct' . $ef->id]['frontend_value'] = $ex->value;
					}
				}
			}
		}

		$cats = $this->getTreeName($categories);
		foreach ($cats AS $cat) {
			if ($cat->id == $baseItem->catid) {
				$item->attr['cat']['value'][] = $cat->id;
				$item->attr['cat']['frontend_value'][] = $cat->name;
			}
		}

		switch ($baseItem->featured) {
			case '0':
				$item->attr['featured']['value'][] = '0';
				$item->attr['featured']['frontend_value'][] = JText::_('COM_JAMEGAFILTER_NOT_FEATURED');
				break;

			case '1':
				$item->attr['featured']['value'][] = '1';
				$item->attr['featured']['frontend_value'][] = JText::_('COM_JAMEGAFILTER_ONLY_FEATURED');
				break;
		}

		$item->attr['tag'] = $this->getItemTags($baseItem);
		$item->attr['author'] = $this->getItemAuthors($baseItem);

		return $item;
	}

	function getTreeName($cats) {
		$catTree = array();
		foreach ( $cats as $cat )
		{
			$nametree = '';
			$tcat = clone $cat;
			foreach( $catTree as $singleCat ) 
			{
				if ($cat->parent == $singleCat->id) {
					$nametree = $singleCat->name.' &raquo; '.$nametree;
					break;
				} 
			}

			$tcat->name = $nametree . $cat->name;
			array_push($catTree, $tcat);
		}

		return $catTree;
	}

	function getItemTags($item) {
		$tags = array();
		$sql = 'SELECT t.id, t.name FROM `#__k2_tags` t
				LEFT JOIN `#__k2_tags_xref` tx ON (tx.tagID = t.id)
				WHERE t.published = 1 
				AND tx.itemID = ' . $item->id;
		$db = JFactory::getDBO();
		$db->setQuery($sql);
		$_tags = $db->loadObjectList();
		foreach ($_tags AS $v) {
			$tags['value'][] = $v->id;
			$tags['frontend_value'][] = $v->name;
		}
		return $tags;
	}

	function getItemAuthors($item) {
		$sql = 'SELECT k2u.userID, u.name FROM #__k2_users k2u
			LEFT JOIN #__users u ON (k2u.userID = u.id)
			WHERE k2u.userID = ' . $item->created_by;
		$db = JFactory::getDBO();
		$db->setQuery($sql);
		$user = $db->loadAssoc();
		$obj = array();
		$obj['value'] = array($user['userID']);
		$obj['frontend_value'] = array($user['name']);
		return $obj;
	}

	function getUrl($baseItem) {
		require_once (JPATH_SITE . '/components/com_k2/helpers/route.php');
		$url = K2HelperRoute::getItemRoute($baseItem->id . ':' . $baseItem->alias, $baseItem->catid);
		return $url;
	}

	function fetchChild($parent) {
		$mainframe = JFactory::getApplication();
		$user = JFactory::getUser();
		$aid = (int) $user->get('aid');
		$db = JFactory::getDBO();
		$query = "SELECT * FROM #__k2_categories WHERE parent = '{$parent}' ";
		$query .= " AND published=1 AND trash=0";
		$query .= " ORDER BY ordering ASC";
		$db->setQuery($query);
		$cats = $db->loadObjectList();

		return $cats;
	}

	function _fetchElement($id, $indent, $list, $maxlevel = 9999, $level = 0, $type = 1) {
		$children = $this->fetchChild($id);

		if (@$children && $level <= $maxlevel) {
			foreach ($children as $v) {
				$id = $v->id;

				if ($type) {
					$pre = '|_&nbsp;.';
					$spacer = '.&nbsp;&nbsp;';
				} else {
					$pre = '- ';
					$spacer = '&nbsp;&nbsp;';
				}

				$txt = $pre . $v->name;
				$pt = $v->parent;
				$list[$id] = $v;
				$list[$id]->treename = "{$indent}{$txt}";
				$list[$id]->children = count(@$children);
				$list[$id]->haschild = true;
				$list[$id]->level = $level;
				$list = $this->_fetchElement($id, $indent . $spacer, $list, $maxlevel, $level + 1, $type);
			}
		} else {
			if (isset($list[$id])) {
				$list[$id]->haschild = false;
			}
		}
		return $list;
	}

}
